#include <windows.h>

#include "CSkinBase.h"
#include "..\util\StrUtil.h"

//////////////////////////////////////////////////////////////////////////////
//tHg񂩂tHg쐬
//:stSkinFont -> tHgւ̃|C^
//߂l:tHgnh
HFONT CreateFontFromSkinFont(PTDIGI_SKIN_FONT *pStSkinFont){
	HFONT hFont;
	DWORD dwFnWeight=0;	
	
	if(pStSkinFont == NULL)return NULL;

	//tHgTCY肷
	switch(pStSkinFont->nFlagBold){
	case 0:dwFnWeight = FW_THIN;break;
	case 1:dwFnWeight = FW_BOLD;break;
	case 2:dwFnWeight = FW_EXTRABOLD;break;
	case 3:dwFnWeight = FW_ULTRABOLD;break;
	case 4:dwFnWeight = FW_BLACK;break;
	default:dwFnWeight = FW_DONTCARE;break;
	}

	hFont = CreateFont(pStSkinFont->nFontSize, 0, 0, 0,
			dwFnWeight, 
			FALSE, FALSE, FALSE, 
			DEFAULT_CHARSET ,OUT_TT_PRECIS ,//SHIFTJIS_CHARSET , OUT_TT_PRECIS , 
			CLIP_DEFAULT_PRECIS, 
			ANTIALIASED_QUALITY,//DEFAULT_QUALITY, 
			DEFAULT_PITCH , pStSkinFont->pszFontName);

	return hFont;
}

//////////////////////////////////////////////////////////////////////////////
//{^J
//:*pBtnInfo -> {^ւ̃|C^
//߂lȂ
void SafeReleaseBtnInfo(PTDIGI_SKIN_BUTTON *pBtnInfo){
	if(pBtnInfo->pszBmpDefault != NULL)delete [] pBtnInfo->pszBmpDefault;
	if(pBtnInfo->pszBmpSelect != NULL)delete [] pBtnInfo->pszBmpSelect;
	if(pBtnInfo->pszBmpPush != NULL)delete [] pBtnInfo->pszBmpPush;
	if(pBtnInfo->pszBmpDeisable != NULL)delete [] pBtnInfo->pszBmpDeisable;

	ZeroMemory(pBtnInfo,sizeof(PTDIGI_SKIN_BUTTON));
}

//////////////////////////////////////////////////////////////////////////////
//'=a,b,c,...'Ŏ镶񂩂琔𓾂
//:pBuf->'=a,b,c,...'Ŏ镶
//     iNum -> 擾鐔l̐(piOut Ŏwϐ(int)̐)
//     piOut -> o͐obt@
//߂l: TRUE 
//        FALSE s
BOOL CSkinBase::GetNumber(char *pBuf,int iNum,int *piOut){
	int i,j,k;
	int length;
	char *pBuf2;
	char szBuf[8];//{^ʒu̍ő9999܂
	
	if(pBuf == NULL)return FALSE;
	
	length = strlen(pBuf);
		
	pBuf2 = new char[length+5];
	if(pBuf2 == NULL)return FALSE;

	//' '菜
	j=0;
	for(i=0;i<length;++i){
		if(pBuf[i] != ' '){
			pBuf2[j] = pBuf[i];
			++j;
		}
	}
	pBuf2[j]='\0';
	
	length = j;
	
	//'='܂ł
	for(i=0;i<length;++i)
		if(pBuf2[i] == '=')break;
	
	if(i==length){
		delete [] pBuf2;
		return FALSE;
	}
	
	for(k=0;k<iNum;++k){
		j=0;
		++i;
		for(;i<length;++i){
			if(j>=5)break;
			
			//s܂́u,vꍇɒTI
			if(pBuf2[i] == ',')break;
			if(pBuf2[i] == '\n')break;
			if(pBuf2[i] == '\r')break;
			
			szBuf[j] = pBuf2[i];
			++j;
		}
		if(j==5){
			delete [] pBuf2;
			return FALSE;
		}
		szBuf[j] = '\0';
		//lɕϊ
		piOut[k] = atoi(szBuf);
	}
	
	delete [] pBuf2;
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//obt@""擾
//:pBuf->""܂ޕ
//     pDstBuf -> ۑobt@
//߂l:
int CSkinBase::GetString(char *pBuf,char *pDstBuf){
	int i,j,length,fChk;
	
	if(pBuf == NULL)return 0;
	
	fChk = FALSE;
	
	length = strlen(pBuf);
	
	i=0;
	j=0;
	while(i<length){
		if(fChk == TRUE){
			if(pDstBuf != NULL)
				pDstBuf[j] = pBuf[i];
			++j;
		}
		if(pBuf[i] == '\"'){
			if(fChk == TRUE){
				--j;
				break;
			}
			fChk = TRUE;
		}
		++i;
	}
	if(pDstBuf != NULL)
		pDstBuf[j] = '\0';
	
	return j+1;
}

//////////////////////////////////////////////////////////////////////////////
//obt@""擾
//:pBuf->""܂ޕ
//     pDstBuf -> ۑobt@w|C^̕ۑ
//߂l:TRUE 
//       FALSE s
BOOL CSkinBase::GetString2(char *pChkBuf,char **pBuf){
	
	if(pChkBuf == NULL)return FALSE;
	if(pBuf == NULL)return FALSE;

	int cbLength;

	cbLength = GetString(pChkBuf,NULL);
	if(*pBuf != NULL)delete [] (*pBuf);
		if(cbLength > 0){
		*pBuf = new char [cbLength];
		if(*pBuf != NULL){
			GetString(pChkBuf,*pBuf);
		}
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//"{}"łꂽobt@擾
//:pBuf -> Ώۂ̕
//     pDstBuf -> {}󂯎󂯎obt@
//߂l:
int CSkinBase::GetConfigrationSet(char *pBuf,char *pDstBuf){
	int i,j,length,fChk;
	
	if(pBuf == NULL)return 0;
	
	fChk = FALSE;
	
	length = strlen(pBuf);
	
	i=0;
	j=0;
	while(i<length){
		if(pBuf[i] == '}' && fChk == TRUE)break;

		if(fChk == TRUE){
			if(pDstBuf != NULL)
				pDstBuf[j] = pBuf[i];
			++j;
		}
		if(pBuf[i] == '{')fChk = TRUE;
		

		++i;
	}
	if(pDstBuf != NULL)
		pDstBuf[j] = '\0';
	
	return j+1;
}

//////////////////////////////////////////////////////////////////////////////
//"{}"łꂽobt@擾
//:pBuf -> Ώۂ̕
//     pDstBuf -> obt@ւ̃|C^(͎擾)
//߂l:擾TCY
int CSkinBase::GetConfigrationSet2(char *pBuf,char **pDstBuf){
	int iLength;
	iLength = GetConfigrationSet(pBuf,NULL);
	if(iLength <= 0)return FALSE;
	
	if(pDstBuf == NULL)return iLength;

	*pDstBuf = new char [iLength];
	ZeroMemory((*pDstBuf),iLength);
	
	GetConfigrationSet(pBuf,(*pDstBuf));
	
	return iLength;
}

//////////////////////////////////////////////////////////////////////////////
//tHgɑ΂p[^擾
//:pBuf -> tHg񂪂obt@
//     pRcPos -> ̈󂯎obt@
//     pStSkinFont -> tHg󂯎΂ӂ
//߂l TRUE 
//       FALSE s
BOOL CSkinBase::GetFontParam(char *pBuf,RECT *pRcPos,PTDIGI_SKIN_FONT *pStSkinFont){
	
	int i,nBufLength;
	char *pChkBuf=NULL;
	int cbChkBuf;
	int nGetVal[4];

	if(pBuf == NULL)return FALSE;
	if(pStSkinFont == NULL)return FALSE;

	//obt@̃TCY擾
	nBufLength = strlen(pBuf);

	for(i=0;i<nBufLength;++i){
		//s܂ł̃TCY擾
		cbChkBuf = strlenex(&pBuf[i]);
		if(pChkBuf != NULL){
			delete [] pChkBuf;
			pChkBuf = NULL;
		}
		
		//s܂ł̃obt@擾
		pChkBuf = new char [cbChkBuf + 1];
		CopyMemory(pChkBuf,&pBuf[i],cbChkBuf);
		pChkBuf[cbChkBuf] = '\0';

		//\ʒu擾
		if(iStrCmpPosition(pChkBuf,"rect") != -1 && pRcPos != NULL){
			GetNumber(pChkBuf,4,&nGetVal[0]);
			pRcPos->left   = nGetVal[0];
			pRcPos->top    = nGetVal[1];
			pRcPos->right  = nGetVal[2];
			pRcPos->bottom = nGetVal[3];
		}

		//̔wiF擾
		if(iStrCmpPosition(pChkBuf,"backColor") != -1 && pStSkinFont != NULL){
			GetNumber(pChkBuf,3,&nGetVal[0]);
			pStSkinFont->backColor.rgbRed		= nGetVal[0];
			pStSkinFont->backColor.rgbGreen		= nGetVal[1];
			pStSkinFont->backColor.rgbBlue		= nGetVal[2];
			pStSkinFont->backColor.rgbReserved  = 0;
		}

		//̐F擾
		if(iStrCmpPosition(pChkBuf,"textColor") != -1 && pStSkinFont != NULL){
			GetNumber(pChkBuf,3,&nGetVal[0]);
			pStSkinFont->textColor.rgbRed		= nGetVal[0];
			pStSkinFont->textColor.rgbGreen		= nGetVal[1];
			pStSkinFont->textColor.rgbBlue		= nGetVal[2];
			pStSkinFont->textColor.rgbReserved  = 0;
		}

		//tHg擾
		if(iStrCmpPosition(pChkBuf,"fontName") != -1 && pStSkinFont != NULL){
			GetString2(pChkBuf,&pStSkinFont->pszFontName);
		}

		//tHgTCY擾
		if(iStrCmpPosition(pChkBuf,"fontSize") != -1 && pStSkinFont != NULL){
			GetNumber(pChkBuf,1,&nGetVal[0]);
			pStSkinFont->nFontSize = nGetVal[0];
		}

		//{[hp[^擾
		if(iStrCmpPosition(pChkBuf,"bold") != -1 && pStSkinFont != NULL){
			GetNumber(pChkBuf,1,&nGetVal[0]);
			pStSkinFont->nFlagBold = nGetVal[0];
		}

		//{[hp[^擾
		if(iStrCmpPosition(pChkBuf,"Transparent") != -1 && pStSkinFont != NULL){
			GetNumber(pChkBuf,1,&nGetVal[0]);
			pStSkinFont->nTransparent = nGetVal[0];
		}

		i += cbChkBuf;
	}

	if(pChkBuf != NULL){
		delete [] pChkBuf;
		pChkBuf = NULL;
	}

	return TRUE;
}

